Bug 834226 - `do' does not clean $@ on success sometimes
`do' does not clean $@ on success sometimes
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: perl (Show other bugs)
16
Unspecified Unspecified
unspecified Severity high
: ---
: ---
Assigned To: Petr Pisar
Fedora Extras Quality Assurance
https://rt.perl.org/rt3/Public/Bug/Di...
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2012-06-21 05:26 EDT by Petr Pisar
Modified: 2012-09-20 16:38 EDT (History)
11 users (show)

See Also:
Fixed In Version: perl-5.16.1-233.fc19
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2012-09-20 16:38:54 EDT
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Petr Pisar 2012-06-21 05:26:58 EDT
The `eval' and `do' functions should clear $@ variable on success. However this does not happen always:

eval { die "shouldn't see this\n" };
do 'no such file';
warn $@ if $@;

This has been fixed in upstream commit:

commit a3ff80c12c16886edf9acdd3d172798e50defdb3
Author: Eric Brine <ikegami@adaelis.com>
Date:   Mon Jun 18 14:56:32 2012 -0400

    RT#113730 - $@ should be cleared on "do" IO error.


Tested with perl-5.14.2-198.fc16.x86_64. All Fedoras are affected probably.
Comment 1 Petr Pisar 2012-09-11 04:25:33 EDT
This issue has been fixed in upstream with commit:

commit a3ff80c12c16886edf9acdd3d172798e50defdb3
Author: Eric Brine <ikegami@adaelis.com>
Date:   Mon Jun 18 14:56:32 2012 -0400

    RT#113730 - $@ should be cleared on "do" IO error.

perl 5.16.1 is affected too.
Comment 2 Fedora Update System 2012-09-11 09:26:26 EDT
perl-5.16.1-230.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/perl-5.16.1-230.fc18
Comment 3 Fedora Update System 2012-09-11 12:53:27 EDT
perl-5.14.2-214.fc17 has been submitted as an update for Fedora 17.
https://admin.fedoraproject.org/updates/perl-5.14.2-214.fc17
Comment 4 Fedora Update System 2012-09-11 13:01:28 EDT
perl-5.14.2-200.fc16 has been submitted as an update for Fedora 16.
https://admin.fedoraproject.org/updates/perl-5.14.2-200.fc16
Comment 5 Fedora Update System 2012-09-11 15:12:26 EDT
Package perl-5.16.1-230.fc18:
* should fix your issue,
* was pushed to the Fedora 18 testing repository,
* should be available at your local mirror within two days.
Update it with:
# su -c 'yum update --enablerepo=updates-testing perl-5.16.1-230.fc18'
as soon as you are able to.
Please go to the following url:
https://admin.fedoraproject.org/updates/FEDORA-2012-13814/perl-5.16.1-230.fc18
then log in and leave karma (feedback).
Comment 6 Fedora Update System 2012-09-14 08:04:12 EDT
perl-5.16.1-231.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/perl-5.16.1-231.fc18
Comment 7 Fedora Update System 2012-09-14 08:17:14 EDT
perl-5.14.2-215.fc17 has been submitted as an update for Fedora 17.
https://admin.fedoraproject.org/updates/perl-5.14.2-215.fc17
Comment 8 Fedora Update System 2012-09-14 08:18:27 EDT
perl-5.14.2-201.fc16 has been submitted as an update for Fedora 16.
https://admin.fedoraproject.org/updates/perl-5.14.2-201.fc16
Comment 9 Fedora Update System 2012-09-20 16:38:54 EDT
perl-5.16.1-231.fc18 has been pushed to the Fedora 18 stable repository.  If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.